//*****************************************************************************
// File Name            : svga_syss_sw1.c
//-----------------------------------------------------------------------------
// Function             : OpenCores IP EtherIP
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2013/10/24
//*****************************************************************************

#include <stdio.h>
#include "platform.h"
#include "xbasic_types.h"
#include "XIOModule.h"

#define IOM_GPO_ADDR    0x80000010
#define IOM_GPO  (*((volatile int *)IOM_GPO_ADDR))
#define USER_GPO_ADDR    0xC0000000
#define USER_GPO  (*((volatile int *)USER_GPO_ADDR))
#define USER_GPI_ADDR    0xC0000004
#define LPDDR_BASEADDR   0xD0000000
#define USER_GPO_ADDR    0xC0000000
#define USER_GPI_ADDRT   0xC0000004
#define VGA_CTRL_OFFSET    0x100
#define VGA_VRAM_SEL_OFFSET (VGA_CTRL_OFFSET + 0x0)
#define VGA_RGB_DATA_OFFSET (VGA_CTRL_OFFSET + 0x4)

void print(char *str);
int str2int(char* adr_st )
{
	int adr;
	char tmp_st[5];
 	  tmp_st[0]=adr_st[0];
 	  tmp_st[1]=adr_st[1];
 	  tmp_st[2]=adr_st[2];
 	  tmp_st[3]=adr_st[3];
 	  tmp_st[4]='\0';
 	  adr = strtol(tmp_st,NULL,16) * 0x10000 ;
 	  tmp_st[0]=adr_st[4];
 	  tmp_st[1]=adr_st[5];
 	  tmp_st[2]=adr_st[6];
 	  tmp_st[3]=adr_st[7];
 	  tmp_st[4]='\0';
 	  adr = adr + strtol(tmp_st,NULL,16);
  return adr;
}

void adr_st_cp(char* in_st,char *tmp_st,int base )
{ //char * tmp_st;
    tmp_st[0]=in_st[base];
 	tmp_st[1]=in_st[base + 1];
 	tmp_st[2]=in_st[base + 2];
 	tmp_st[3]=in_st[base + 3];
 	tmp_st[4]=in_st[base + 4];
 	tmp_st[5]=in_st[base + 5];
 	tmp_st[6]=in_st[base + 6];
 	tmp_st[7]=in_st[base + 7];
 	tmp_st[8]='\0';
}
int keyinput_func (char* in_st,int lp, char data){
	//volatile char *in_st;
    int adr;
    //int adr_phy_mdio;
    int *adr_p;
    short *adr_short_p;
    char *adr_byte_p;
    char adr_st[9];
    //volatile char * adr_st;
    int dat;
    unsigned short dat_short;
    unsigned char dat_byte;
    char dat_st[10];
    //char hex_st[]="0123456789abcdef";
    //char *adr_st_p;
    volatile int lp_w;
    int cmd_hit;
    in_st[lp] = data;
     if (in_st[lp]!= 0xd){
    	lp++;
       }
     else{
       cmd_hit = 0;
	   in_st[lp + 1]='\0';
	   xil_printf("\n");
        // byete write
       if (in_st[lp-12]=='w'){
    	 adr_st_cp(in_st,adr_st,lp-11);
    	 adr= str2int(adr_st);
    	 dat_st[0]=in_st[lp-2];
    	 dat_st[1]=in_st[lp-1];
         dat_st[2]='\0';
         dat = strtol(dat_st,NULL,16);
         adr_byte_p = (char *)adr;
         *adr_byte_p = (char)dat;
         xil_printf("W1B ad= %x da=%02x \n" ,adr,dat);
	     cmd_hit = 1;
    	 }
       // 2byte write
       if ((lp==15)&&(in_st[lp-15]=='w')&&(in_st[lp-14]=='w')){
         adr_st_cp(in_st,adr_st,lp-13);
         adr= str2int(adr_st);
         dat_st[0]=in_st[lp-4];
         dat_st[1]=in_st[lp-3];
         dat_st[2]=in_st[lp-2];
         dat_st[3]=in_st[lp-1];
         dat_st[4]='\0';
         dat = strtol(dat_st,NULL,16);
         adr_short_p = (short *)adr;
         *adr_short_p = (short)dat;
         xil_printf("W2B ad= %x da=%04x \n" ,adr,dat);
	     cmd_hit = 1;
         }
       // 4byte write
       if ((lp==18)&&(in_st[lp-18]=='W')){
         adr_st_cp(in_st,adr_st,lp-17);
         adr= str2int(adr_st);
         dat_st[0]=in_st[lp-8];
         dat_st[1]=in_st[lp-7];
         dat_st[2]=in_st[lp-6];
         dat_st[3]=in_st[lp-5];
         dat_st[4]=in_st[lp-4];
         dat_st[5]=in_st[lp-3];
         dat_st[6]=in_st[lp-2];
         dat_st[7]=in_st[lp-1];
         dat_st[8]='\0';
         dat= str2int(dat_st);
         adr_p = (int *)adr;
         *adr_p = dat;
         xil_printf("W4B ad= %x da=%08x \n" ,adr,dat);
	     cmd_hit = 1;
         }
    // 4bytes Read
    if (in_st[lp-9]=='R'){
         adr_st_cp(in_st,adr_st,lp-8);
         adr= str2int(adr_st);
         adr_p = (int *)adr;
         dat = *adr_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //xil_printf("\n");
         xil_printf("R4B ad= %x da=%08x \n" ,adr,dat);
	     cmd_hit = 1;
      }
    // 2bytes Read
    if ((in_st[lp-9]=='r')&&(in_st[lp-10]=='r')){
         adr_st_cp(in_st,adr_st,lp-8);
         adr= str2int(adr_st);
         adr_short_p = (short *)adr;
         dat_short = *adr_short_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //xil_printf("\n");
         xil_printf("R2B ad= %x da=%04x \n" ,adr,dat_short);
	     cmd_hit = 1;
      }
    // 1bytes Read
    if ((lp==9)&&(in_st[lp-9]=='r')){
         adr_st_cp(in_st,adr_st,lp-8);
         adr= str2int(adr_st);
         adr_byte_p = (char *)adr;
         dat_byte = *adr_byte_p;
         for(lp_w=0;lp_w < 2 ;lp_w++ );
         //xil_printf("\n");
         xil_printf("R1B ad= %x da=%02x \n" ,adr,dat_byte);
	     cmd_hit = 1;
      }
    // L cmd
    if (in_st[lp-1]=='L'){
         cmd_hit = 1;
         if (USER_GPO==0x0){
    	     xil_printf("LED on\n");
             IOM_GPO  = 0x3 ;
             USER_GPO = 0x3;
         }
         else{
    	     xil_printf("LED off\n");
             IOM_GPO  = 0x0 ;
             USER_GPO = 0x0;
         }
	   }
    // S cmd
    if (in_st[lp-1]=='S'){
	     xil_printf("S\n");
         cmd_hit = 1;
	   }
    // invalid command
    if (cmd_hit == 0)
	   	 xil_printf("invalid command\n");
    lp = 0;
    xil_printf(">");
    }
	return( lp );
}


void draw_box( int *lp_c, int *lp_v,int *lp_h )
{
int p_adr;
int lp_x,lp_y;
   for(lp_x=0;lp_x<40;lp_x++){
     for(lp_y=0;lp_y<40;lp_y++){
 	   p_adr = (*lp_v)*40000*4 + (*lp_h)*200 + 20 + 16000 + lp_x *800*4 + lp_y*4;
       if(*lp_c==0)
         (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0xff0000;//red
       else if(*lp_c==1)
         (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0xff00; //green
       else if(*lp_c==2)
         (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0xff; //blue
       else
         (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0xffffff; //white
    }
   }
//next box
  if (*lp_h<16 )
    (*lp_h)++;
  else{
    *lp_h=0;
    if(*lp_v<12)
     (*lp_v)++;
    else{
      *lp_v=0;
      if(*lp_c<3)
     	(*lp_c)++;
      else
     	*lp_c=0;
      }
    }
}


int main()
{
    u32 uDevId = XPAR_IOMODULE_0_DEVICE_ID;
    XIOModule NfdsIOMdule;
    u32 data;
    u8 rx_buf[10];
    char in_st[32];
    int lp=0;
	//int tmp;
	int tmp0,tmp1,tmp2,tmp3;
	int lp_c=0;
	int lp_v=0;
	int lp_h=0;
	int lp_x;
	int p_adr;
    init_platform();
    XIOModule_Initialize(&NfdsIOMdule, uDevId);
    IOM_GPO =0;
    USER_GPO =0;
    XIOModule_IoWriteWord(&NfdsIOMdule,VGA_RGB_DATA_OFFSET,0x808080);
    XIOModule_IoWriteWord(&NfdsIOMdule,VGA_VRAM_SEL_OFFSET,0x0);
    /*
    for(lp_y=0;lp_y<600;lp_y++){
  	for(lp_x=0;lp_x<800;lp_x++){
  	  p_adr =  lp_y*800*4 + lp_x*4;
  	 (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0x801080; //vram
  	 //(*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = lp_y*3200 + lp_x; //vram
  	}
    }
    */
  	for(lp_x=0;lp_x<8;lp_x++){
  	  p_adr = lp_x*4;
  	 (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0x801080; //vram
  	}

    (*((volatile int *)(LPDDR_BASEADDR + 0x0))) = 0x10203;
    (*((volatile int *)(LPDDR_BASEADDR + 0x4))) = 0x40506;
    (*((volatile int *)(LPDDR_BASEADDR + 0x8))) = 0x70809;
    for(lp=0;lp<10;lp++){

    }
    (*((volatile int *)(LPDDR_BASEADDR + 0xC))) = 0xa0b0c;
    tmp0 =(*((volatile int *)LPDDR_BASEADDR )) ;
    tmp1 =(*((volatile int *)(LPDDR_BASEADDR + 0x4))) ;
    tmp2 =(*((volatile int *)(LPDDR_BASEADDR + 0x8))) ;
    tmp3 =(*((volatile int *)(LPDDR_BASEADDR + 0xc))) ;
  	for(lp_x=4;lp_x<800;lp_x++){
  	  p_adr = lp_x*4;
  	 (*((volatile int *)(LPDDR_BASEADDR +p_adr)  )) = 0x801080; //vram
  	}
    if(tmp0==0x10203)
      xil_printf("OK ");
    else
      xil_printf("NG ");
    xil_printf("lpddr read %x\n\r",tmp0);
    if(tmp1==0x40506)
      xil_printf("OK ");
    else
      xil_printf("NG ");
    xil_printf("lpddr read %x\n\r",tmp1);
    if(tmp2==0x70809)
      xil_printf("OK ");
    else
      xil_printf("NG ");
    xil_printf("lpddr read %x\n\r",tmp2);
    if(tmp3==0xa0b0c)
      xil_printf("OK ");
    else
      xil_printf("NG ");
    xil_printf("lpddr read %x\n\r",tmp3);
    print("start \n\r");
    print(">");
    lp=0;
    
    while(1){
    //
   // draw_box(&lp_c,&lp_v,&lp_h);
    //
    if ((data = XIOModule_Recv(&NfdsIOMdule, rx_buf, 1)) != 0){
	  XIOModule_Send(&NfdsIOMdule, &rx_buf[0],1);
      lp = keyinput_func(in_st,lp,rx_buf[0]);
	}
    //
    draw_box(&lp_c,&lp_v,&lp_h);

    }
    return 0;
}
